# test_lab09.py
# Lillian Lee (LJL2) and Walker White (wmw2)
# Mar 26, 2017

"""Test cases for lab09.py. Omitting specs on the test procedures because
their descriptions are totally obvious from the procedure names."""

import cornelltest as ct
import lab09
import inspect # for automatically getting function name
import sys, StringIO # for testing printouts

def test_numberof():
    print "Running " + inspect.stack()[0][3]

    # dictionaries can't have lists as keys, so using tuples
    test_cases={
        ((5, 3, 3455, 74, 74, 74, 3), 74):3,
        ((5, 3, 3455, 74, 74, 74, 3), 3): 2,
        ((5, 3, 3455, 74, 74, 74, 3), 4): 0,
        ((4,), 4): 1,
        ((4, 4), 4): 2,
        ((), 3):0
    }

    for test_input in test_cases:
        print '\ttrying ' + str(test_input)
        output = lab09.numberof(list(test_input[0]), test_input[1])
        ct.assert_equals(test_cases[test_input], output)


def test_replace():
    print "Running " + inspect.stack()[0][3]

    # dictionaries can't have lists as keys, so using tuples
    test_cases = {
        ((5, 6), 5, 4): [4, 6],
        ((5, 6), 6, 4): [5, 4],
        ((5, 5), 5, -4): [-4, -4],
        ((), 1, 2): [],
        ((5, 3, 3455, 74, 74, 74, 3), 3, 20): [5, 20, 3455, 74, 74, 74, 20],
        ((5, 3, 3455, 74, 74, 74, 3), 1, 20): [5, 3, 3455, 74, 74, 74, 3],
    }

    for test_input in test_cases:
        print '\ttrying ' + str(test_input)
        test_list = list(test_input[0])
        output = lab09.replace(test_list, test_input[1], test_input[2])
        ct.assert_equals(test_cases[test_input], output)
        # see if new list is truly a COPY, even if no change happened
        ct.assert_false(output is test_list)


def test_sum_nested_list():
    print "Running " + inspect.stack()[0][3]
    # dictionaries can't have lists as keys, so using list instead of dict.
    test_cases = [
        [0, 0],
        [4, 4],
        [[0, [2, 5], [8, [-10, -1]]],     4],
        [[0, [2, 5, []], [8, [-10, -1]]],     4],
        [[], 0]
    ]

    for item in test_cases:
        test_input = item[0]
        correct = item[1]
        print '\ttrying ' + str(test_input)
        ct.assert_equals(correct, lab09.sum_nested_list(test_input))


def test_print_nested_list():
    print "Running " + inspect.stack()[0][3]

    test_cases = [
        ["cs1110", "cs1110\n"],
        [['this', ['is', 'a'], 'list', ['list', 'list' ]],
         "this\nis\na\nlist\nlist\nlist\n"
        ],
        [[[['cs1110', 'opython'], 'nested'], 'recursion', 'test'],
         "cs1110\nopython\nnested\nrecursion\ntest\n"
        ],
        [[['this'], ['is', ['a', ['very', 'very', 'very'], ['nes ted', 'list']]]],
         "this\nis\na\nvery\nvery\nvery\nnes ted\nlist\n"
        ]
    ]

    for tc in test_cases:
        inlist = tc[0]
        answer = tc[1]
        print '\ttrying ' + str(inlist)

        # magic to be able to store print output somewhere
        old_stdout = sys.stdout
        capturer = StringIO.StringIO()
        sys.stdout = capturer
        lab09.print_nested_list(inlist)
        sys.stdout = old_stdout
        output = capturer.getvalue()
        try:
            ct.assert_equals(answer, output)
        except:
            print
            print 'What SHOULD have been printed:'
            print answer
            print
            print "The code's output"
            print output
            exit()





# Script Code
if __name__ == '__main__':
    test_numberof()
    test_replace()
    test_sum_nested_list()
    test_print_nested_list()
    print "All tests passed"